// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelcurse<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "curse"), "main");
	private final ModelPart curse;
	private final ModelPart head;
	private final ModelPart left_jaw;
	private final ModelPart right_jaw;
	private final ModelPart left_leg;
	private final ModelPart left_arm;
	private final ModelPart body;
	private final ModelPart right_arm;
	private final ModelPart right_leg;

	public Modelcurse(ModelPart root) {
		this.curse = root.getChild("curse");
		this.head = this.curse.getChild("head");
		this.left_jaw = this.head.getChild("left_jaw");
		this.right_jaw = this.head.getChild("right_jaw");
		this.left_leg = this.curse.getChild("left_leg");
		this.left_arm = this.curse.getChild("left_arm");
		this.body = this.curse.getChild("body");
		this.right_arm = this.curse.getChild("right_arm");
		this.right_leg = this.curse.getChild("right_leg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition curse = partdefinition.addOrReplaceChild("curse", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition head = curse.addOrReplaceChild("head", CubeListBuilder.create(),
				PartPose.offset(0.0F, -20.0F, 0.0F));

		PartDefinition left_jaw = head.addOrReplaceChild("left_jaw", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.2618F));

		PartDefinition cube_r1 = left_jaw.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(15, 15)
						.addBox(0.0F, -8.0F, -2.0F, 3.0F, 8.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(30, 0)
						.addBox(-1.0F, -8.0F, 1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 2)
						.addBox(-1.0F, -6.0F, 1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 6)
						.addBox(-1.0F, -2.0F, 1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 4)
						.addBox(-1.0F, -4.0F, 1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(21, 13)
						.addBox(-1.0F, -8.0F, -1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(24, 13)
						.addBox(-1.0F, -6.0F, -1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(27, 13)
						.addBox(-1.0F, -4.0F, -1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(27, 28)
						.addBox(-1.0F, -2.0F, -1.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.2618F));

		PartDefinition right_jaw = head.addOrReplaceChild("right_jaw", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.2618F));

		PartDefinition cube_r2 = right_jaw.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(30, 18)
						.addBox(0.0F, -3.0F, -2.1F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 16)
						.addBox(0.0F, -5.0F, -2.1F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 14)
						.addBox(0.0F, -7.0F, -2.1F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 12)
						.addBox(0.0F, -3.0F, -5.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 10)
						.addBox(0.0F, -5.0F, -5.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(30, 8)
						.addBox(0.0F, -7.0F, -5.9F, 1.0F, 1.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(0, 15)
						.addBox(-3.0F, -8.0F, -6.0F, 3.0F, 8.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 4.0F, 0.0F, 0.0F, -0.2618F));

		PartDefinition left_leg = curse.addOrReplaceChild("left_leg", CubeListBuilder.create().texOffs(0, 28).addBox(
				-1.0F, 0.0F, -1.0F, 2.0F, 10.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.offset(2.0F, -10.0F, 0.0F));

		PartDefinition left_arm = curse.addOrReplaceChild("left_arm", CubeListBuilder.create(),
				PartPose.offset(3.0F, -19.0F, 0.0F));

		PartDefinition cube_r3 = left_arm
				.addOrReplaceChild("cube_r3",
						CubeListBuilder.create().texOffs(18, 28).addBox(-1.0F, -1.0F, -1.0F, 2.0F, 10.0F, 2.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(1.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.2618F));

		PartDefinition body = curse.addOrReplaceChild("body", CubeListBuilder.create().texOffs(0, 0).addBox(-1.0F,
				-10.0F, -2.0F, 6.0F, 10.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(-2.0F, -10.0F, 0.0F));

		PartDefinition right_arm = curse.addOrReplaceChild("right_arm", CubeListBuilder.create(),
				PartPose.offset(-3.0F, -19.0F, 0.0F));

		PartDefinition cube_r4 = right_arm
				.addOrReplaceChild("cube_r4",
						CubeListBuilder.create().texOffs(9, 28).addBox(-1.0F, -1.0F, -1.0F, 2.0F, 10.0F, 2.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(-1.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.2618F));

		PartDefinition right_leg = curse.addOrReplaceChild("right_leg", CubeListBuilder.create().texOffs(21, 0)
				.addBox(-1.0F, 0.0F, -1.0F, 2.0F, 10.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-2.0F, -10.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 48, 48);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		curse.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.right_jaw.zRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.left_jaw.zRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
	}
}