// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelprison_cube<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "prison_cube"), "main");
	private final ModelPart spirit_cube;

	public Modelprison_cube(ModelPart root) {
		this.spirit_cube = root.getChild("spirit_cube");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition spirit_cube = partdefinition.addOrReplaceChild("spirit_cube",
				CubeListBuilder.create().texOffs(14, 29)
						.addBox(-4.0F, -6.0F, 2.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-9.0F, -12.0F, 3.0F, 8.0F, 8.0F, 8.0F, new CubeDeformation(0.0F)).texOffs(0, 17)
						.addBox(-5.5F, -12.5F, 6.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 25)
						.addBox(-3.5F, -4.5F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(7, 25)
						.addBox(-5.5F, -4.5F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(14, 25)
						.addBox(-7.5F, -4.5F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(28, 21)
						.addBox(-7.5F, -4.5F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(28, 17)
						.addBox(-3.5F, -4.5F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(21, 25)
						.addBox(-5.5F, -4.5F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(7, 17)
						.addBox(-9.5F, -6.0F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(14, 17)
						.addBox(-9.5F, -11.0F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 21)
						.addBox(-9.5F, -8.5F, 6.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(7, 21)
						.addBox(-1.5F, -6.5F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(14, 21)
						.addBox(-1.5F, -6.5F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(21, 21)
						.addBox(-1.5F, -10.5F, 8.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(21, 17)
						.addBox(-1.5F, -10.5F, 4.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(28, 25)
						.addBox(-6.0F, -7.0F, 10.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 28)
						.addBox(-6.0F, -10.0F, 10.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(7, 29)
						.addBox(-8.0F, -6.0F, 2.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 29)
						.addBox(-8.0F, -11.0F, 2.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(21, 29)
						.addBox(-4.0F, -11.0F, 2.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 31)
						.addBox(-6.0F, -8.5F, 2.6F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(5.0F, 28.0F, -7.0F));

		return LayerDefinition.create(meshdefinition, 40, 40);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		spirit_cube.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
	}
}