
package net.mcreator.minekaisen.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;

import net.mcreator.minekaisen.entity.MahoragaEntity;
import net.mcreator.minekaisen.client.model.Modelmahoraga;

import com.mojang.blaze3d.vertex.PoseStack;

public class MahoragaRenderer extends MobRenderer<MahoragaEntity, Modelmahoraga<MahoragaEntity>> {
	public MahoragaRenderer(EntityRendererProvider.Context context) {
		super(context, new Modelmahoraga(context.bakeLayer(Modelmahoraga.LAYER_LOCATION)), 0.5f);
	}

	@Override
	protected void scale(MahoragaEntity entity, PoseStack poseStack, float f) {
		poseStack.scale(1.8f, 1.8f, 1.8f);
	}

	@Override
	public ResourceLocation getTextureLocation(MahoragaEntity entity) {
		return new ResourceLocation("mine_kaisen:textures/entities/mahoraga.png");
	}
}
