
/*
 *	MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.minekaisen.init;

import org.lwjgl.glfw.GLFW;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.client.event.RegisterKeyMappingsEvent;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.client.Minecraft;
import net.minecraft.client.KeyMapping;

import net.mcreator.minekaisen.network.Technique5Message;
import net.mcreator.minekaisen.network.Technique3Message;
import net.mcreator.minekaisen.network.Technique2Message;
import net.mcreator.minekaisen.network.Technique1Message;
import net.mcreator.minekaisen.network.DomainExpansionMessage;
import net.mcreator.minekaisen.MineKaisenMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD, value = {Dist.CLIENT})
public class MineKaisenModKeyMappings {
	public static final KeyMapping TECHNIQUE_1 = new KeyMapping("key.mine_kaisen.technique_1", GLFW.GLFW_KEY_Z, "key.categories.mine_kaisen") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				MineKaisenMod.PACKET_HANDLER.sendToServer(new Technique1Message(0, 0));
				Technique1Message.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping TECHNIQUE_2 = new KeyMapping("key.mine_kaisen.technique_2", GLFW.GLFW_KEY_X, "key.categories.mine_kaisen") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				MineKaisenMod.PACKET_HANDLER.sendToServer(new Technique2Message(0, 0));
				Technique2Message.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping DOMAIN_EXPANSION = new KeyMapping("key.mine_kaisen.domain_expansion", GLFW.GLFW_KEY_G, "key.categories.mine_kaisen") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				MineKaisenMod.PACKET_HANDLER.sendToServer(new DomainExpansionMessage(0, 0));
				DomainExpansionMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping TECHNIQUE_3 = new KeyMapping("key.mine_kaisen.technique_3", GLFW.GLFW_KEY_C, "key.categories.mine_kaisen") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				MineKaisenMod.PACKET_HANDLER.sendToServer(new Technique3Message(0, 0));
				Technique3Message.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping TECHNIQUE_5 = new KeyMapping("key.mine_kaisen.technique_5", GLFW.GLFW_KEY_B, "key.categories.mine_kaisen") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				MineKaisenMod.PACKET_HANDLER.sendToServer(new Technique5Message(0, 0));
				Technique5Message.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};

	@SubscribeEvent
	public static void registerKeyMappings(RegisterKeyMappingsEvent event) {
		event.register(TECHNIQUE_1);
		event.register(TECHNIQUE_2);
		event.register(DOMAIN_EXPANSION);
		event.register(TECHNIQUE_3);
		event.register(TECHNIQUE_5);
	}

	@Mod.EventBusSubscriber({Dist.CLIENT})
	public static class KeyEventListener {
		@SubscribeEvent
		public static void onClientTick(TickEvent.ClientTickEvent event) {
			if (Minecraft.getInstance().screen == null) {
				TECHNIQUE_1.consumeClick();
				TECHNIQUE_2.consumeClick();
				DOMAIN_EXPANSION.consumeClick();
				TECHNIQUE_3.consumeClick();
				TECHNIQUE_5.consumeClick();
			}
		}
	}
}
