package net.mcreator.minekaisen.procedures;

import net.minecraftforge.network.NetworkDirection;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.network.Connection;
import net.minecraft.core.BlockPos;
import net.minecraft.client.player.AbstractClientPlayer;
import net.minecraft.advancements.AdvancementProgress;
import net.minecraft.advancements.Advancement;

import net.mcreator.minekaisen.init.MineKaisenModMobEffects;
import net.mcreator.minekaisen.init.MineKaisenModEntities;
import net.mcreator.minekaisen.MineKaisenMod;

import java.util.List;
import java.util.Iterator;

import dev.kosmx.playerAnim.minecraftApi.PlayerAnimationRegistry;
import dev.kosmx.playerAnim.minecraftApi.PlayerAnimationAccess;
import dev.kosmx.playerAnim.api.layered.ModifierLayer;
import dev.kosmx.playerAnim.api.layered.KeyframeAnimationPlayer;
import dev.kosmx.playerAnim.api.layered.IAnimation;

public class DomainExpansionOnKeyPressedProcedure {
	public static void execute(LevelAccessor world, Entity entity) {
		if (entity == null)
			return;
		if (!(entity instanceof LivingEntity _livEnt0 && _livEnt0.hasEffect(MineKaisenModMobEffects.DOMAIN_CANCELATION.get()))) {
			if ((entity instanceof LivingEntity _livEnt && _livEnt.hasEffect(MineKaisenModMobEffects.VESSEL.get()) ? _livEnt.getEffect(MineKaisenModMobEffects.VESSEL.get()).getAmplifier() : 0) >= 2) {
				if (entity instanceof LivingEntity _entity && !_entity.level().isClientSide())
					_entity.addEffect(new MobEffectInstance(MineKaisenModMobEffects.DOMAIN_CANCELATION.get(),
							(int) (24000 - (entity instanceof LivingEntity _livEnt && _livEnt.hasEffect(MineKaisenModMobEffects.VESSEL.get()) ? _livEnt.getEffect(MineKaisenModMobEffects.VESSEL.get()).getAmplifier() : 0) * 1100), 0, false, false));
				if (entity instanceof ServerPlayer _player) {
					Advancement _adv = _player.server.getAdvancements().getAdvancement(new ResourceLocation("mine_kaisen:domain_expansion_advancement"));
					AdvancementProgress _ap = _player.getAdvancements().getOrStartProgress(_adv);
					if (!_ap.isDone()) {
						for (String criteria : _ap.getRemainingCriteria())
							_player.getAdvancements().award(_adv, criteria);
					}
				}
				if (world.isClientSide()) {
					if (entity instanceof AbstractClientPlayer player) {
						var animation = (ModifierLayer<IAnimation>) PlayerAnimationAccess.getPlayerAssociatedData(player).get(new ResourceLocation("mine_kaisen", "player_animation"));
						if (animation != null && !animation.isActive()) {
							animation.setAnimation(new KeyframeAnimationPlayer(PlayerAnimationRegistry.getAnimation(new ResourceLocation("mine_kaisen", "malevolent_shrine"))));
						}
					}
				}
				if (!world.isClientSide()) {
					if (entity instanceof Player && world instanceof ServerLevel srvLvl_) {
						List<Connection> connections = srvLvl_.getServer().getConnection().getConnections();
						synchronized (connections) {
							Iterator<Connection> iterator = connections.iterator();
							while (iterator.hasNext()) {
								Connection connection = iterator.next();
								if (!connection.isConnecting() && connection.isConnected())
									MineKaisenMod.PACKET_HANDLER.sendTo(new SetupAnimationsProcedure.MineKaisenModAnimationMessage(Component.literal("malevolent_shrine"), entity.getId(), false), connection, NetworkDirection.PLAY_TO_CLIENT);
							}
						}
					}
				}
				MineKaisenMod.queueServerWork(7, () -> {
					if (!world.isClientSide() && world.getServer() != null)
						world.getServer().getPlayerList().broadcastSystemMessage(Component.literal(("<" + entity.getDisplayName().getString() + "> Domain Expansion: Malevolent Shrine")), false);
					MineKaisenMod.queueServerWork(13, () -> {
						if (world instanceof ServerLevel _level) {
							Entity entityToSpawn = MineKaisenModEntities.MALEVOLENT_SHRINE.get().spawn(_level, BlockPos.containing(entity.getX() - (entity.getLookAngle().x + 7), entity.getY(), entity.getZ() - (entity.getLookAngle().z + 7)),
									MobSpawnType.MOB_SUMMONED);
							if (entityToSpawn != null) {
								entityToSpawn.setYRot(world.getRandom().nextFloat() * 360F);
							}
						}
					});
				});
			} else if (entity instanceof LivingEntity _livEnt16 && _livEnt16.hasEffect(MineKaisenModMobEffects.LIMITLESS.get()) && entity instanceof LivingEntity _livEnt17 && _livEnt17.hasEffect(MineKaisenModMobEffects.SIX_EYES.get())) {
				if (entity instanceof LivingEntity _entity && !_entity.level().isClientSide())
					_entity.addEffect(new MobEffectInstance(MineKaisenModMobEffects.DOMAIN_CANCELATION.get(), 2400, 0, false, false));
				if (entity instanceof ServerPlayer _player) {
					Advancement _adv = _player.server.getAdvancements().getAdvancement(new ResourceLocation("mine_kaisen:domain_expansion_advancement"));
					AdvancementProgress _ap = _player.getAdvancements().getOrStartProgress(_adv);
					if (!_ap.isDone()) {
						for (String criteria : _ap.getRemainingCriteria())
							_player.getAdvancements().award(_adv, criteria);
					}
				}
				MineKaisenMod.queueServerWork(7, () -> {
					if (!world.isClientSide() && world.getServer() != null)
						world.getServer().getPlayerList().broadcastSystemMessage(Component.literal(("<" + entity.getDisplayName().getString() + "> Domain Expansion: Infinite Void")), false);
					MineKaisenMod.queueServerWork(13, () -> {
						if (world instanceof ServerLevel _level) {
							Entity entityToSpawn = MineKaisenModEntities.INFINITE_VOID.get().spawn(_level, BlockPos.containing(entity.getX(), entity.getY(), entity.getZ()), MobSpawnType.MOB_SUMMONED);
							if (entityToSpawn != null) {
								entityToSpawn.setYRot(world.getRandom().nextFloat() * 360F);
							}
						}
					});
				});
			}
		}
	}
}
