// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modeldivine_dog<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "divine_dog"), "main");
	private final ModelPart divine_dog;
	private final ModelPart left_leg;
	private final ModelPart back_left_leg;
	private final ModelPart back_right_leg;
	private final ModelPart tail;
	private final ModelPart head;
	private final ModelPart body;
	private final ModelPart right_leg;

	public Modeldivine_dog(ModelPart root) {
		this.divine_dog = root.getChild("divine_dog");
		this.left_leg = this.divine_dog.getChild("left_leg");
		this.back_left_leg = this.divine_dog.getChild("back_left_leg");
		this.back_right_leg = this.divine_dog.getChild("back_right_leg");
		this.tail = this.divine_dog.getChild("tail");
		this.head = this.divine_dog.getChild("head");
		this.body = this.divine_dog.getChild("body");
		this.right_leg = this.divine_dog.getChild("right_leg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition divine_dog = partdefinition.addOrReplaceChild("divine_dog", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition left_leg = divine_dog.addOrReplaceChild("left_leg", CubeListBuilder.create().texOffs(0, 38)
				.addBox(-1.0F, 0.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(2.0F, -7.0F, -5.0F));

		PartDefinition back_left_leg = divine_dog.addOrReplaceChild("back_left_leg", CubeListBuilder.create()
				.texOffs(24, 40).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(2.0F, -7.0F, 5.0F));

		PartDefinition back_right_leg = divine_dog.addOrReplaceChild("back_right_leg", CubeListBuilder.create()
				.texOffs(37, 0).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-2.0F, -7.0F, 5.0F));

		PartDefinition tail = divine_dog.addOrReplaceChild("tail", CubeListBuilder.create().texOffs(25, 30).addBox(
				-1.0F, -1.0F, 0.0F, 2.0F, 2.0F, 7.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -12.0F, 6.0F));

		PartDefinition head = divine_dog.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(0, 32)
						.addBox(-2.0F, 0.0F, -7.0F, 4.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(25, 19)
						.addBox(-3.0F, -3.0F, -4.0F, 6.0F, 6.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 19)
						.addBox(-4.0F, -4.0F, -2.0F, 8.0F, 8.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -10.0F, -6.0F));

		PartDefinition body = divine_dog.addOrReplaceChild("body", CubeListBuilder.create().texOffs(0, 0).addBox(0.0F,
				-5.0F, -1.0F, 6.0F, 6.0F, 12.0F, new CubeDeformation(0.0F)), PartPose.offset(-3.0F, -8.0F, -5.0F));

		PartDefinition right_leg = divine_dog.addOrReplaceChild("right_leg", CubeListBuilder.create().texOffs(15, 32)
				.addBox(-1.0F, 0.0F, -1.0F, 2.0F, 7.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-2.0F, -7.0F, -5.0F));

		return LayerDefinition.create(meshdefinition, 64, 64);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		divine_dog.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.back_right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.tail.yRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.back_left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
	}
}