// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelfinger_bearer<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "finger_bearer"), "main");
	private final ModelPart finger_bearer;
	private final ModelPart body;
	private final ModelPart head;
	private final ModelPart right_arm;
	private final ModelPart left_leg;
	private final ModelPart left_arm;
	private final ModelPart right_leg;

	public Modelfinger_bearer(ModelPart root) {
		this.finger_bearer = root.getChild("finger_bearer");
		this.body = this.finger_bearer.getChild("body");
		this.head = this.finger_bearer.getChild("head");
		this.right_arm = this.finger_bearer.getChild("right_arm");
		this.left_leg = this.finger_bearer.getChild("left_leg");
		this.left_arm = this.finger_bearer.getChild("left_arm");
		this.right_leg = this.finger_bearer.getChild("right_leg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition finger_bearer = partdefinition.addOrReplaceChild("finger_bearer", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition body = finger_bearer.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 17)
						.addBox(-4.0F, 1.0F, -2.0F, 8.0F, 5.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(25, 17)
						.addBox(-4.0F, -6.0F, -2.0F, 8.0F, 5.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(50, 13)
						.addBox(-4.0F, -1.0F, -2.0F, 3.0F, 2.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(51, 32)
						.addBox(-1.0F, -1.0F, 1.0F, 2.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(50, 20)
						.addBox(1.0F, -1.0F, -2.0F, 3.0F, 2.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(51, 27)
						.addBox(-0.5F, -0.5F, -2.0F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -18.0F, 0.0F));

		PartDefinition head = finger_bearer.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(0, 0)
						.addBox(-4.0F, -8.0F, -4.0F, 8.0F, 8.0F, 8.0F, new CubeDeformation(0.0F)).texOffs(0, 44)
						.addBox(-3.0F, -8.5F, -4.5F, 1.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(21, 44)
						.addBox(2.0F, -8.5F, -4.5F, 1.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(42, 44)
						.addBox(0.5F, -8.5F, -4.5F, 1.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(50, 0)
						.addBox(-1.5F, -8.5F, -4.5F, 1.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -24.0F, 0.0F));

		PartDefinition right_arm = finger_bearer.addOrReplaceChild("right_arm", CubeListBuilder.create().texOffs(34, 27)
				.addBox(-4.0F, -2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-4.0F, -22.0F, 0.0F));

		PartDefinition left_leg = finger_bearer.addOrReplaceChild("left_leg", CubeListBuilder.create().texOffs(17, 27)
				.addBox(0.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -12.0F, 0.0F));

		PartDefinition left_arm = finger_bearer.addOrReplaceChild("left_arm", CubeListBuilder.create().texOffs(33, 0)
				.addBox(0.0F, -2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(4.0F, -22.0F, 0.0F));

		PartDefinition right_leg = finger_bearer.addOrReplaceChild("right_leg", CubeListBuilder.create().texOffs(0, 27)
				.addBox(-4.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -12.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 80, 80);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		finger_bearer.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}