// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelgojo_cloak<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "gojo_cloak"), "main");
	private final ModelPart cloak;
	private final ModelPart left_arm;
	private final ModelPart body;
	private final ModelPart right_arm;

	public Modelgojo_cloak(ModelPart root) {
		this.cloak = root.getChild("cloak");
		this.left_arm = this.cloak.getChild("left_arm");
		this.body = this.cloak.getChild("body");
		this.right_arm = this.cloak.getChild("right_arm");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition cloak = partdefinition.addOrReplaceChild("cloak", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition left_arm = cloak.addOrReplaceChild("left_arm",
				CubeListBuilder.create().texOffs(30, 7)
						.addBox(-0.5F, -2.5F, -2.5F, 4.0F, 1.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(0, 32)
						.addBox(2.5F, -1.5F, -2.5F, 1.0F, 7.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(46, 37)
						.addBox(-0.5F, -1.5F, -2.5F, 3.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(40, 46)
						.addBox(-0.5F, -1.5F, 1.5F, 3.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(5.0F, -10.0F, 0.0F));

		PartDefinition body = cloak.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(13, 15)
						.addBox(3.5F, -1.5F, -2.5F, 1.0F, 13.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(13, 34)
						.addBox(0.5F, -1.5F, -2.5F, 3.0F, 13.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(22, 37)
						.addBox(-3.5F, -1.5F, -2.5F, 3.0F, 13.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-4.5F, -1.5F, -2.5F, 1.0F, 13.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(13, 0)
						.addBox(-3.5F, -1.5F, 1.5F, 7.0F, 13.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(26, 15)
						.addBox(-4.5F, -2.5F, -3.5F, 2.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)).texOffs(31, 42)
						.addBox(-2.5F, -2.5F, -2.5F, 5.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(31, 37)
						.addBox(-2.5F, -2.5F, 2.5F, 5.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(26, 26)
						.addBox(2.5F, -2.5F, -3.5F, 2.0F, 2.0F, 8.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -11.0F, 0.0F));

		PartDefinition right_arm = cloak.addOrReplaceChild("right_arm",
				CubeListBuilder.create().texOffs(31, 46)
						.addBox(-2.5F, -1.5F, 1.5F, 3.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 19)
						.addBox(-3.5F, -1.5F, -2.5F, 1.0F, 7.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(0, 45)
						.addBox(-2.5F, -1.5F, -2.5F, 3.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(30, 0)
						.addBox(-3.5F, -2.5F, -2.5F, 4.0F, 1.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-5.0F, -10.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 64, 64);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		cloak.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
	}
}