// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modeltoji_pants<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "toji_pants"), "main");
	private final ModelPart clothes;
	private final ModelPart shirt;
	private final ModelPart body;
	private final ModelPart left_arm;
	private final ModelPart right_arm;
	private final ModelPart pants;
	private final ModelPart left_leg;
	private final ModelPart right_leg;

	public Modeltoji_pants(ModelPart root) {
		this.clothes = root.getChild("clothes");
		this.shirt = this.clothes.getChild("shirt");
		this.body = this.shirt.getChild("body");
		this.left_arm = this.shirt.getChild("left_arm");
		this.right_arm = this.shirt.getChild("right_arm");
		this.pants = this.clothes.getChild("pants");
		this.left_leg = this.pants.getChild("left_leg");
		this.right_leg = this.pants.getChild("right_leg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition clothes = partdefinition.addOrReplaceChild("clothes", CubeListBuilder.create(),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition shirt = clothes.addOrReplaceChild("shirt", CubeListBuilder.create(),
				PartPose.offset(0.0F, -19.0F, 0.0F));

		PartDefinition body = shirt.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 0)
						.addBox(-4.0F, -2.0F, -2.2F, 8.0F, 12.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(19, 0)
						.addBox(-4.0F, -2.2F, -2.0F, 8.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 14)
						.addBox(-4.0F, -2.0F, 1.2F, 8.0F, 12.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(19, 6)
						.addBox(-4.201F, -2.0F, -2.001F, 1.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(19, 23)
						.addBox(3.201F, -2.0F, -2.001F, 1.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -3.0F, 0.0F));

		PartDefinition left_arm = shirt.addOrReplaceChild("left_arm",
				CubeListBuilder.create().texOffs(55, 0)
						.addBox(-2.0F, -2.0F, -2.2F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(11, 40)
						.addBox(-2.0F, -2.2F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(47, 12)
						.addBox(1.201F, -2.0F, -2.001F, 1.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(44, 0)
						.addBox(-2.0F, -2.0F, 1.2F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(47, 21)
						.addBox(-2.201F, -2.0F, -2.001F, 1.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(6.0F, -3.0F, 0.0F));

		PartDefinition right_arm = shirt.addOrReplaceChild("right_arm",
				CubeListBuilder.create().texOffs(11, 55)
						.addBox(-2.0F, -2.0F, -2.2F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(41, 6)
						.addBox(-2.0F, -2.2F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(39, 48)
						.addBox(1.201F, -2.0F, -2.001F, 1.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(33, 57)
						.addBox(-2.0F, -2.0F, 1.2F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(50, 48)
						.addBox(-2.201F, -2.0F, -2.001F, 1.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-6.0F, -3.0F, 0.0F));

		PartDefinition pants = clothes.addOrReplaceChild("pants", CubeListBuilder.create(),
				PartPose.offset(0.0F, 0.0F, 0.0F));

		PartDefinition left_leg = pants.addOrReplaceChild("left_leg",
				CubeListBuilder.create().texOffs(52, 30)
						.addBox(-2.4F, 5.5F, -2.0F, 1.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(58, 11)
						.addBox(-2.0F, 5.5F, -2.41F, 4.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(52, 38)
						.addBox(1.4F, 5.5F, -2.0F, 1.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(55, 57)
						.addBox(-2.0F, 5.5F, 1.41F, 4.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(30, 24)
						.addBox(-2.0F, -1.8F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(28, 42)
						.addBox(-2.0F, -1.5F, -2.21F, 4.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(11, 28)
						.addBox(-2.0F, -1.0F, -2.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(11, 31)
						.addBox(-2.0F, 0.0F, -2.5F, 1.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(11, 46)
						.addBox(-2.0F, -1.5F, 1.21F, 4.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(30, 30)
						.addBox(1.2F, -1.5F, -2.0F, 1.0F, 7.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 40)
						.addBox(-2.2F, -1.5F, -2.0F, 1.0F, 7.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offset(2.0F, -11.0F, 0.0F));

		PartDefinition right_leg = pants.addOrReplaceChild("right_leg",
				CubeListBuilder.create().texOffs(0, 28)
						.addBox(-2.2F, -1.5F, -2.0F, 1.0F, 7.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(30, 6)
						.addBox(1.2F, -1.5F, -2.0F, 1.0F, 7.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(41, 30)
						.addBox(-2.0F, -1.5F, 1.21F, 4.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(41, 39)
						.addBox(-2.0F, -1.5F, -2.21F, 4.0F, 7.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(30, 18)
						.addBox(-2.0F, -1.8F, -2.0F, 4.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(44, 57)
						.addBox(-2.0F, 5.5F, 1.41F, 4.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(22, 51)
						.addBox(1.4F, 5.5F, -2.0F, 1.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(58, 6)
						.addBox(-2.0F, 5.5F, -2.41F, 4.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 52)
						.addBox(-2.4F, 5.5F, -2.0F, 1.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(11, 36)
						.addBox(0.0F, -1.0F, -2.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(41, 12)
						.addBox(1.0F, 0.0F, -2.5F, 1.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-2.0F, -11.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 80, 80);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		clothes.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}