package net.mcreator.minekaisen.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.11.1
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelmahoraga<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("mine_kaisen", "modelmahoraga"), "main");
	public final ModelPart mahoraga;
	public final ModelPart body;
	public final ModelPart left_leg;
	public final ModelPart left_arm;
	public final ModelPart right_arm;
	public final ModelPart sword;
	public final ModelPart right_leg;
	public final ModelPart head;
	public final ModelPart wheel;

	public Modelmahoraga(ModelPart root) {
		this.mahoraga = root.getChild("mahoraga");
		this.body = this.mahoraga.getChild("body");
		this.left_leg = this.mahoraga.getChild("left_leg");
		this.left_arm = this.mahoraga.getChild("left_arm");
		this.right_arm = this.mahoraga.getChild("right_arm");
		this.sword = this.right_arm.getChild("sword");
		this.right_leg = this.mahoraga.getChild("right_leg");
		this.head = this.mahoraga.getChild("head");
		this.wheel = this.head.getChild("wheel");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition mahoraga = partdefinition.addOrReplaceChild("mahoraga", CubeListBuilder.create(), PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition body = mahoraga.addOrReplaceChild("body", CubeListBuilder.create().texOffs(0, 17).addBox(-4.0F, -2.0F, -2.0F, 8.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -22.0F, 0.0F));
		PartDefinition left_leg = mahoraga.addOrReplaceChild("left_leg", CubeListBuilder.create().texOffs(33, 0).addBox(0.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -12.0F, 0.0F));
		PartDefinition left_arm = mahoraga.addOrReplaceChild("left_arm", CubeListBuilder.create().texOffs(17, 34).addBox(0.0F, -2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(4.0F, -22.0F, 0.0F));
		PartDefinition right_arm = mahoraga.addOrReplaceChild("right_arm", CubeListBuilder.create().texOffs(0, 34).addBox(-4.0F, -2.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(-4.0F, -22.0F, 0.0F));
		PartDefinition sword = right_arm.addOrReplaceChild("sword", CubeListBuilder.create(), PartPose.offset(-2.0F, 10.0F, 0.0F));
		PartDefinition cube_r1 = sword.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(72, 36).addBox(1.5F, 8.0F, -0.5F, 1.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(49, 71).addBox(1.5F, 5.0F, -1.0F, 1.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(51, 61)
						.addBox(1.5F, -1.0F, -1.5F, 1.0F, 6.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(34, 34).addBox(-2.5F, -7.0F, -2.5F, 5.0F, 6.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, 0.0F, 3.1416F, 0.0F));
		PartDefinition right_leg = mahoraga.addOrReplaceChild("right_leg", CubeListBuilder.create().texOffs(25, 17).addBox(-4.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -12.0F, 0.0F));
		PartDefinition head = mahoraga.addOrReplaceChild("head", CubeListBuilder.create().texOffs(0, 0).addBox(-4.0F, -7.7836F, -4.0237F, 8.0F, 8.0F, 8.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, -24.2164F, 0.0237F));
		PartDefinition cube_r2 = head.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(51, 54).addBox(-1.0F, 0.5F, -1.0F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(0, 59).addBox(-1.0F, -2.499F, -1.0F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(3.0F, -3.7836F, -3.0237F, 0.0F, 0.3927F, 0.0F));
		PartDefinition cube_r3 = head.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(55, 33).addBox(-1.0F, 0.5F, -1.0F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(34, 54).addBox(-1.0F, -2.499F, -1.0F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-3.0F, -3.7836F, -3.0237F, 0.0F, -0.3927F, 0.0F));
		PartDefinition cube_r4 = head.addOrReplaceChild("cube_r4",
				CubeListBuilder.create().texOffs(59, 23).addBox(-0.02F, 1.0F, 0.05F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(59, 16).addBox(-0.02F, -1.5F, 0.05F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-4.8F, -4.7836F, 0.1763F, 0.0F, -0.1309F, 0.0F));
		PartDefinition cube_r5 = head.addOrReplaceChild("cube_r5",
				CubeListBuilder.create().texOffs(51, 46).addBox(-1.98F, 0.0F, 0.05F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(0, 51).addBox(-1.98F, 2.5F, 0.05F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.8F, -6.7836F, 0.1763F, 0.0F, 0.1309F, 0.0F));
		PartDefinition cube_r6 = head.addOrReplaceChild("cube_r6",
				CubeListBuilder.create().texOffs(50, 0).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(42, 25).addBox(-1.0F, 2.5F, -1.0F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(4.0F, -6.7836F, -4.0237F, 0.0F, 0.3927F, 0.0F));
		PartDefinition cube_r7 = head.addOrReplaceChild("cube_r7",
				CubeListBuilder.create().texOffs(34, 61).addBox(-1.98F, 1.5F, 0.05F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(17, 59).addBox(-1.98F, 4.0F, 0.05F, 2.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(4.8F, -7.7836F, 0.1763F, 0.0F, 0.1309F, 0.0F));
		PartDefinition cube_r8 = head.addOrReplaceChild("cube_r8",
				CubeListBuilder.create().texOffs(17, 51).addBox(-0.02F, -0.5F, 0.05F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(50, 8).addBox(-0.02F, -3.0F, 0.05F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-6.8F, -3.7836F, 0.1763F, 0.0F, -0.1309F, 0.0F));
		PartDefinition cube_r9 = head.addOrReplaceChild("cube_r9",
				CubeListBuilder.create().texOffs(34, 46).addBox(-1.0F, -0.5F, -1.0F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)).texOffs(42, 17).addBox(-1.0F, -3.0F, -1.0F, 2.0F, 1.0F, 6.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-4.0F, -3.7836F, -4.0237F, 0.0F, -0.3927F, 0.0F));
		PartDefinition wheel = head.addOrReplaceChild("wheel", CubeListBuilder.create(), PartPose.offset(0.0F, -11.7836F, -0.0237F));
		PartDefinition cube_r10 = wheel.addOrReplaceChild("cube_r10",
				CubeListBuilder.create().texOffs(72, 33).addBox(0.0F, 0.0F, -1.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(61, 72).addBox(3.0F, 0.0F, -1.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, -0.2164F, -0.9763F, -1.5708F, 1.3526F, -1.5708F));
		PartDefinition cube_r11 = wheel.addOrReplaceChild("cube_r11",
				CubeListBuilder.create().texOffs(14, 72).addBox(5.0F, 0.0F, -1.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(56, 72).addBox(3.0F, 0.0F, -1.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, 1.7315F, 7.8104F, -1.5708F, 1.3526F, -1.5708F));
		PartDefinition cube_r12 = wheel.addOrReplaceChild("cube_r12",
				CubeListBuilder.create().texOffs(7, 72).addBox(1.0F, 0.0F, -0.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 72).addBox(-3.0F, 0.0F, -0.5F, 2.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(68, 55)
						.addBox(-7.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(71, 72).addBox(-5.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(66, 72)
						.addBox(4.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(40, 68).addBox(5.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(60, 61)
						.addBox(-4.0F, 0.0F, -2.0F, 1.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(55, 40).addBox(3.0F, 0.0F, -2.0F, 1.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -0.2182F, 0.0F, 0.0F));
		PartDefinition cube_r13 = wheel.addOrReplaceChild("cube_r13", CubeListBuilder.create().texOffs(60, 67).addBox(3.0F, -0.5F, -3.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(2.0F, 0.8658F, 3.9052F, -1.5708F, 1.3526F, -1.5708F));
		PartDefinition cube_r14 = wheel.addOrReplaceChild("cube_r14",
				CubeListBuilder.create().texOffs(71, 63).addBox(0.0F, 0.0F, -0.5F, 3.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(68, 30).addBox(-3.0F, 0.0F, -0.5F, 3.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(68, 50)
						.addBox(5.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 75).addBox(4.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(41, 73)
						.addBox(-5.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(22, 71).addBox(-7.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -2.8378F, -0.762F, 2.9284F));
		PartDefinition cube_r15 = wheel.addOrReplaceChild("cube_r15",
				CubeListBuilder.create().texOffs(71, 60).addBox(0.0F, 0.0F, -0.5F, 3.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(59, 30).addBox(-3.0F, 0.0F, -0.5F, 3.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(69, 67)
						.addBox(-7.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(36, 73).addBox(-5.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(31, 73)
						.addBox(4.0F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(68, 45).addBox(5.0F, -0.5F, -1.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -0.3038F, -0.762F, 0.2132F));
		PartDefinition cube_r16 = wheel.addOrReplaceChild("cube_r16", CubeListBuilder.create().texOffs(67, 10).addBox(3.0F, -0.5F, -3.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(2.0F, 2.1644F, 9.763F, -1.5708F, 1.3526F, -1.5708F));
		PartDefinition cube_r17 = wheel.addOrReplaceChild("cube_r17", CubeListBuilder.create().texOffs(31, 68).addBox(3.0F, -0.5F, -3.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(2.0F, -0.4329F, -1.9526F, -1.5708F, 1.3526F, -1.5708F));
		PartDefinition cube_r18 = wheel.addOrReplaceChild("cube_r18",
				CubeListBuilder.create().texOffs(67, 5).addBox(3.0F, 0.001F, -1.5F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(67, 0).addBox(-4.0F, 0.001F, -1.5F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -2.8378F, 0.762F, -2.9284F));
		PartDefinition cube_r19 = wheel.addOrReplaceChild("cube_r19",
				CubeListBuilder.create().texOffs(66, 40).addBox(3.0F, 0.001F, -1.5F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(22, 66).addBox(-4.0F, 0.001F, -1.5F, 1.0F, 1.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -0.3038F, 0.762F, -0.2132F));
		PartDefinition cube_r20 = wheel.addOrReplaceChild("cube_r20",
				CubeListBuilder.create().texOffs(11, 66).addBox(3.0F, 0.0F, -2.0F, 1.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 66).addBox(-4.0F, 0.0F, -2.0F, 1.0F, 1.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 0.0F, -1.5708F, 1.3526F, -1.5708F));
		return LayerDefinition.create(meshdefinition, 80, 80);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		mahoraga.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
	}
}
