
package net.mcreator.minekaisen.potion;

import net.minecraft.world.entity.ai.attributes.AttributeMap;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.effect.MobEffectCategory;
import net.minecraft.world.effect.MobEffect;

import net.mcreator.minekaisen.procedures.VesselOnEffectActiveTickProcedure;
import net.mcreator.minekaisen.procedures.VesselEffectExpiresProcedure;

public class VesselMobEffect extends MobEffect {
	public VesselMobEffect() {
		super(MobEffectCategory.NEUTRAL, -13893632);
	}

	@Override
	public void applyEffectTick(LivingEntity entity, int amplifier) {
		VesselOnEffectActiveTickProcedure.execute(entity.level(), entity.getX(), entity.getY(), entity.getZ(), entity);
	}

	@Override
	public void removeAttributeModifiers(LivingEntity entity, AttributeMap attributeMap, int amplifier) {
		super.removeAttributeModifiers(entity, attributeMap, amplifier);
		VesselEffectExpiresProcedure.execute(entity.level(), entity.getX(), entity.getY(), entity.getZ());
	}

	@Override
	public boolean isDurationEffectTick(int duration, int amplifier) {
		return true;
	}
}
