package net.mcreator.minekaisen.procedures;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.TamableAnimal;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.network.chat.Component;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.BlockPos;

import net.mcreator.minekaisen.init.MineKaisenModMobEffects;
import net.mcreator.minekaisen.init.MineKaisenModEntities;
import net.mcreator.minekaisen.entity.ReversalRedEntity;
import net.mcreator.minekaisen.entity.DivineDogWhiteEntity;
import net.mcreator.minekaisen.entity.DivineDogBlackEntity;
import net.mcreator.minekaisen.entity.CleaveProjectileEntity;

import java.util.Comparator;

public class Technique1OnKeyPressedProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		if (entity instanceof LivingEntity _livEnt0 && _livEnt0.hasEffect(MineKaisenModMobEffects.VESSEL.get())) {
			if (world instanceof ServerLevel projectileLevel) {
				Projectile _entityToSpawn = new Object() {
					public Projectile getArrow(Level level, Entity shooter, float damage, int knockback) {
						AbstractArrow entityToSpawn = new CleaveProjectileEntity(MineKaisenModEntities.CLEAVE_PROJECTILE.get(), level);
						entityToSpawn.setOwner(shooter);
						entityToSpawn.setBaseDamage(damage);
						entityToSpawn.setKnockback(knockback);
						entityToSpawn.setSilent(true);
						entityToSpawn.setCritArrow(true);
						return entityToSpawn;
					}
				}.getArrow(projectileLevel, entity, 10, 0);
				_entityToSpawn.setPos(x, (y + 1.5), z);
				_entityToSpawn.shoot((entity.getLookAngle().x), (entity.getLookAngle().y), (entity.getLookAngle().z), 1, 0);
				projectileLevel.addFreshEntity(_entityToSpawn);
			}
			if (!world.isClientSide() && world.getServer() != null)
				world.getServer().getPlayerList().broadcastSystemMessage(Component.literal(("<" + entity.getDisplayName().getString() + "> Cleave")), false);
		}
		if (entity instanceof LivingEntity _livEnt8 && _livEnt8.hasEffect(MineKaisenModMobEffects.LIMITLESS.get())) {
			if (world instanceof ServerLevel projectileLevel) {
				Projectile _entityToSpawn = new Object() {
					public Projectile getArrow(Level level, Entity shooter, float damage, int knockback) {
						AbstractArrow entityToSpawn = new ReversalRedEntity(MineKaisenModEntities.REVERSAL_RED.get(), level);
						entityToSpawn.setOwner(shooter);
						entityToSpawn.setBaseDamage(damage);
						entityToSpawn.setKnockback(knockback);
						entityToSpawn.setSilent(true);
						return entityToSpawn;
					}
				}.getArrow(projectileLevel, entity, 12, 1);
				_entityToSpawn.setPos(x, (y + 1.5), z);
				_entityToSpawn.shoot((entity.getLookAngle().x), (entity.getLookAngle().y), (entity.getLookAngle().z), 1, 0);
				projectileLevel.addFreshEntity(_entityToSpawn);
			}
			if (!world.isClientSide() && world.getServer() != null)
				world.getServer().getPlayerList().broadcastSystemMessage(Component.literal(("<" + entity.getDisplayName().getString() + "> Cursed Technique Reversal: Red")), false);
		}
		if (!(!world.getEntitiesOfClass(DivineDogBlackEntity.class, AABB.ofSize(new Vec3(x, y, z), 60, 60, 60), e -> true).isEmpty())
				&& !(!world.getEntitiesOfClass(DivineDogWhiteEntity.class, AABB.ofSize(new Vec3(x, y, z), 60, 60, 60), e -> true).isEmpty()) && entity instanceof LivingEntity _livEnt18
				&& _livEnt18.hasEffect(MineKaisenModMobEffects.TEN_SHADOWS.get())) {
			if (world instanceof ServerLevel _level) {
				Entity entityToSpawn = MineKaisenModEntities.DIVINE_DOG_BLACK.get().spawn(_level, BlockPos.containing(x + entity.getLookAngle().x, y, z + entity.getLookAngle().z), MobSpawnType.MOB_SUMMONED);
				if (entityToSpawn != null) {
					entityToSpawn.setYRot(world.getRandom().nextFloat() * 360F);
				}
			}
			if (world instanceof ServerLevel _level) {
				Entity entityToSpawn = MineKaisenModEntities.DIVINE_DOG_WHITE.get().spawn(_level, BlockPos.containing(x - entity.getLookAngle().x, y, z - entity.getLookAngle().z), MobSpawnType.MOB_SUMMONED);
				if (entityToSpawn != null) {
					entityToSpawn.setYRot(world.getRandom().nextFloat() * 360F);
				}
			}
			if (world instanceof ServerLevel _level)
				_level.sendParticles(ParticleTypes.LARGE_SMOKE, (x + entity.getLookAngle().x), y, (z + entity.getLookAngle().z), 30, 2, 2, 2, 0.2);
			if (world instanceof ServerLevel _level)
				_level.sendParticles(ParticleTypes.LARGE_SMOKE, (x - entity.getLookAngle().x), y, (z - entity.getLookAngle().z), 30, 2, 2, 2, 0.2);
			if (((Entity) world.getEntitiesOfClass(DivineDogBlackEntity.class, AABB.ofSize(new Vec3(x, y, z), 60, 60, 60), e -> true).stream().sorted(new Object() {
				Comparator<Entity> compareDistOf(double _x, double _y, double _z) {
					return Comparator.comparingDouble(_entcnd -> _entcnd.distanceToSqr(_x, _y, _z));
				}
			}.compareDistOf(x, y, z)).findFirst().orElse(null)) instanceof TamableAnimal _toTame && entity instanceof Player _owner)
				_toTame.tame(_owner);
			if (((Entity) world.getEntitiesOfClass(DivineDogWhiteEntity.class, AABB.ofSize(new Vec3(x, y, z), 60, 60, 60), e -> true).stream().sorted(new Object() {
				Comparator<Entity> compareDistOf(double _x, double _y, double _z) {
					return Comparator.comparingDouble(_entcnd -> _entcnd.distanceToSqr(_x, _y, _z));
				}
			}.compareDistOf(x, y, z)).findFirst().orElse(null)) instanceof TamableAnimal _toTame && entity instanceof Player _owner)
				_toTame.tame(_owner);
			if (!world.isClientSide() && world.getServer() != null)
				world.getServer().getPlayerList().broadcastSystemMessage(Component.literal(("<" + entity.getDisplayName().getString() + "> Divine Dogs")), false);
		}
	}
}
